#!/usr/bin/env ruby

require 'cgi'

class MapUri

	# Refer to http://portal.cyberjapan.jp/portalsite/version/v4/index.html

	@@base_uri = 'http://cyberjapandata.gsi.go.jp/sqras/all/%s/latest/%s/%s.%s'

	ls = [['地図', ['DJBMM', 'png']], ['空撮', ['DJBMO', 'jpg']], ['空撮1989年', ['NLII4', 'jpg']],
		['空撮1985年', ['NLII3', 'jpg']], ['空撮1981年', ['NLII2', 'jpg']], ['空撮1976年', ['NLII1', 'jpg']]]
	@@layers = []; @@layer_names = []; ls.each {|p|
		@@layer_names << p[0]
		@@layers << [[nil, nil]] * 5 + [['JAIS', 'png']] * 4 + [['BAFD1000K', 'png']] * 3 \
			+ [['BAFD200K', 'png']] * 3 + [p[1]] * 3 + [['FGD', 'png']]
	}

	def uri(x, y, z, l)	# x, y, zoom, layer
		dxy = []; sx = '%07d' % x; sy = '%07d' % y
		dxy << z.to_s
		(0..5).each {|p|
			dxy << sx[p, 1] + sy[p, 1]
		}
		@@base_uri % [@@layers[l][z][0], dxy.join('/'), sx + sy, @@layers[l][z][1]]
	end

	def uris(x, y, z, l, xn = 2, yn = 2)
		uris = []; (0...yn).each {|yp|
			xuris = []; (0...xn).each {|xp|
				xuris << uri(x + xp, y + yp, z, l)
			}
			uris << xuris
		}
		uris
	end

	def luris(x, y, z, l, xn = 2, yn = 2)
		luris = []; (0...@@layers.size).each {|n|
			ll = (l + n) % @@layers.size
			luris << [@@layer_names[ll], uris(x, y, z, ll, xn, yn)]
		}
		luris
	end
end

query = CGI.new
x = query.params['x'][0] =~ /(\d+)/ ? $1.to_i : 57715	# 知立駅
y = query.params['y'][0] =~ /(\d+)/ ? $1.to_i : 25957
z = query.params['z'][0] =~ /(\d+)/ ? $1.to_i : 16
l = query.params['l'][0] =~ /(\d+)/ ? $1.to_i : 53

mapuri = MapUri.new
luris = mapuri.luris(x, y, z, l)

sx = '?x=%d' % x; sy = ';y=%d' % y; sz = ';z=%d' % z; sl = ';l=%d' % l
mod_img = " width='256' height='256' border='0'"
mod_arrow0 = "<FONT size='+2'><B>"; mod_arrow9 = "</B></FONT>"

print <<HTML
Content-Type: text/html; charset=UTF-8

<HTML>
<HEAD><TITLE>過っ去いい地図</TITLE><STYLE type='text/css'><!--
	img { vertical-align: top; }
--></STYLE></HEAD>
<BODY>
<TABLE border='0' cellspacing='0' cellpadding='0'>
	<TR><TD><IMG src='#{luris[0][1][0][0]}'#{mod_img}>
		<TD><IMG src='#{luris[0][1][0][1]}'#{mod_img}>
		<TD valign='bottom'><P align='left'>#{mod_arrow0}<A href='#{sx};y=#{(y - 1).to_s}#{sz + sl}'>↑</A>#{mod_arrow9}
	<TR><TD><IMG src='#{luris[0][1][1][0]}'#{mod_img}>
		<TD><A href='?x=#{(x     << 1).to_s};y=#{(y     << 1).to_s};z=#{(z + 1).to_s}#{sl}'><IMG src='#{luris[1][1][0][0]}'#{mod_img}></A>
		<TD><A href='?x=#{(x + 1 << 1).to_s};y=#{(y     << 1).to_s};z=#{(z + 1).to_s}#{sl}'><IMG src='#{luris[1][1][0][1]}'#{mod_img}></A>
		<TD valign='bottom'><P align='center'><A href='?x=#{(x >> 1).to_s};y=#{(y >> 1).to_s};z=#{(z - 1).to_s}#{sl}'>■Zoom Out■</A>
			<P align='center'>↓#{luris[2][0]}<P align='left'>#{mod_arrow0}<A href='?x=#{(x + 1).to_s}#{sy + sz + sl}'>→</A>#{mod_arrow9}
	<TR><TD valign='top'><P align='right'>#{mod_arrow0}<A href='?x=#{(x - 1).to_s}#{sy + sz + sl}'>←</A>#{mod_arrow9}<P align='center'>↑#{luris[0][0]}
			<P align='center'><A href='#{sx + sy + sz};l=#{(l + 1).to_s}'>↑</A>　　<BR>■Rotate■<BR>　　<A href='#{sx + sy + sz};l=#{(l - 1).to_s}'>↓</A>
		<TD><A href='?x=#{(x     << 1).to_s};y=#{(y + 1 << 1).to_s};z=#{(z + 1).to_s}#{sl}'><IMG src='#{luris[1][1][1][0]}'#{mod_img}></A>
		<TD><A href='?x=#{(x + 1 << 1).to_s};y=#{(y + 1 << 1).to_s};z=#{(z + 1).to_s}#{sl}'><IMG src='#{luris[1][1][1][1]}'#{mod_img}></A>
		<TD><IMG src='#{luris[2][1][0][1]}'#{mod_img}>
	<TR><TD>
		<TD valign='top'><P align='right'>#{mod_arrow0}<A href='#{sx};y=#{(y + 1).to_s}#{sz + sl}'>↓</A>#{mod_arrow9}<P align='center'>↑#{luris[1][0]}
		<TD><IMG src='#{luris[2][1][1][0]}'#{mod_img}>
		<TD><IMG src='#{luris[2][1][1][1]}'#{mod_img}>
</TABLE>
</BODY>
<HTML>
HTML

